/************************************************************************/
/*				pad.c					*/
/*									*/
/*	Pad lines to given minimum length.  (No truncation though!)	*/
/************************************************************************/

/************************************************************************/
/*				contents				*/
/*									*/
/*	doFile()	central step-through-file fn			*/
/*	initStuff()	general initialization				*/
/*	main()								*/
/*	usage() 	print usage msg.				*/
/************************************************************************/

/************************************************************************/
/*				history 				*/
/*									*/
/* 83Feb03 CrT	Created.						*/
/************************************************************************/
#include "a:bdscio.h"
#include "a:dio.h"
#include "a:crtlib.h"

int  padLength; 		/* length to pad lines to, 0 for none	*/
char eof;			/* TRUE if seen eof already		*/

char *fileLine; 		/* current line 			*/

char *nextFree; 		/* next free in textBuf */

/************************************************************************/
/*	doFile()							*/
/************************************************************************/
doFile()   {
    unsigned endExt();
    char *eoln;
    int  len;

    do {

	/* read next line...*/
	eof    = (get1line(&fileLine, &nextFree) == EOF);

	/* find end of line: */
	for (eoln=fileLine;  *eoln;  eoln++);

	/* strip trailing blanks and tabs: */
	while (*(eoln-1)==' '  ||  *(eoln-1)=='\t')   *--eoln = '\0';

	/* print line out: */
	printf("%s", fileLine);

	/* pad to desired length: */
	len = strLen(fileLine);
	if (padLength > len)   {
	    len = padLength - len;
	    while (len--)   putChar(' ');
	}

	/* terminate line: */
	putChar('\n');

	/* delete line: */
	nextFree    = endExt();
    } while (!eof);
}

/************************************************************************/
/*	initStuff()							*/
/************************************************************************/
initStuff()   {
    unsigned endExt(), topOfMem();
    char *arg;

    nextFree	= endExt();	/* store text at end of externs 	*/

    padLength	= 20;		/* default to pad to			*/

    while (arg=dioArg())   {
	if (*arg != '-')    usage();
	else {
	    padLength	= aToI(++arg);
	    if (padLength<0  ||  padLength >1000)   usage();
	    while (*arg)   if (!isDigit(*arg++))    usage();
	}
    }
}

/************************************************************************/
/*	main()								*/
/************************************************************************/
main(argC, argV)
int  argC;
char **argV;
{
    dioInit(&argC, argV);
    initStuff();
    doFile();
    dioFlush();
}

/************************************************************************/
/*	usage() 							*/
/************************************************************************/
usage()   {
    printf("Usage: pad [-lineLength] <a >b\n");
    exit();
}
th] <a >b\